/**
 * Created by fazz on 09/02/2017.
 */

// IE8 array.isArray polyfill
if (!Array.isArray) {
    Array.isArray = function(arg) {
        return Object.prototype.toString.call(arg) === '[object Array]';
    };
}

// IE8 array.indexOf polyfill
if (!Array.prototype.indexOf) {
    Array.prototype.indexOf = function(elt /*, from*/)
    {
        // https://stackoverflow.com/questions/7718711/javascript-triple-greater-than
        var len = this.length >>> 0;

        var from = Number(arguments[1]) || 0;
        from = (from < 0)
            ? Math.ceil(from)
            : Math.floor(from);
        if (from < 0)
            from += len;

        for (; from < len; from++)
        {
            if (from in this &&
                this[from] === elt)
                return from;
        }
        return -1;
    };
}

// https://tc39.github.io/ecma262/#sec-array.prototype.includes
if (!Array.prototype.includes) {
    Object.defineProperty(Array.prototype, 'includes', {
        value: function(searchElement, fromIndex) {

            if (this == null) {
                throw new TypeError('"this" is null or not defined');
            }

            // 1. Let O be ? ToObject(this value).
            var o = Object(this);

            // 2. Let len be ? ToLength(? Get(O, "length")).
            var len = o.length >>> 0;

            // 3. If len is 0, return false.
            if (len === 0) {
                return false;
            }

            // 4. Let n be ? ToInteger(fromIndex).
            //    (If fromIndex is undefined, this step produces the value 0.)
            var n = fromIndex | 0;

            // 5. If n ≥ 0, then
            //  a. Let k be n.
            // 6. Else n < 0,
            //  a. Let k be len + n.
            //  b. If k < 0, let k be 0.
            var k = Math.max(n >= 0 ? n : len - Math.abs(n), 0);

            function sameValueZero(x, y) {
                return x === y || (typeof x === 'number' && typeof y === 'number' && isNaN(x) && isNaN(y));
            }

            // 7. Repeat, while k < len
            while (k < len) {
                // a. Let elementK be the result of ? Get(O, ! ToString(k)).
                // b. If SameValueZero(searchElement, elementK) is true, return true.
                if (sameValueZero(o[k], searchElement)) {
                    return true;
                }
                // c. Increase k by 1.
                k++;
            }

            // 8. Return false
            return false;
        }
    });
}

// find the index of array item with attribute "attr" of value "value"
Array.prototype.indexWithAttr = function(attr, value) {

    // https://stackoverflow.com/questions/7718711/javascript-triple-greater-than
    var len = this.length >>> 0;

    for(var i = 0 ; i < len ; i++) {
        if (i in this && this[i][attr] === value) {
            return i;
        }
    }
    return -1;
};

// return the array item with attribute "attr" of value "value"
Array.prototype.itemWithAttr = function(attr, value) {

    // https://stackoverflow.com/questions/7718711/javascript-triple-greater-than
    var len = this.length >>> 0;

    for(var i = 0 ; i < len ; i++) {
        if (i in this && this[i][attr] === value) {
            return this[i];
        }
    }
    return null;
};

// merges multi-level parameters of obj2 into obj1
function mergeObjects(obj1, obj2) {
    if (typeof(obj1) == 'object' && typeof(obj2) == 'object') {
        for (let attrname in obj2) {
            if (typeof obj2[attrname] == 'object') {
                if (typeof obj1[attrname] != 'object') {
                    obj1[attrname] = {};
                }
                mergeObjects(obj1[attrname], obj2[attrname]);
            } else {
                obj1[attrname] = obj2[attrname];
            }
        }
    }
};

Color = {

    hsl2rgb: function(H, S, L) {
        var t1, t2, r, g, b;
        H /= 60;
        S /= 100;
        L /= 100;
        if (L <= 0.5) {
            t2 = L * (S + 1);
        } else {
            t2 = L + S - (L * S);
        }
        t1 = L * 2 - t2;
        r = Math.min(255, Math.round((this.hue2rgb(t1, t2, H + 2) * 255) + 0.5));
        g = Math.min(255, Math.round((this.hue2rgb(t1, t2, H) * 255) + 0.5));
        b = Math.min(255, Math.round((this.hue2rgb(t1, t2, H - 2) * 255) + 0.5));
        return {r: r, g: g, b: b};
    },

    rgb2hsb: function(R, G, B) {
        var hsl = this.rgb2hsl(R, G, B);
        return this.hsl2hsb(hsl.h, hsl.s, hsl.l);
    },

    hsl2hex: function(H, S, L) {
        var rgb = this.hsl2rgb(H, S, L);
        return this.rgb2hex(rgb.r, rgb.g, rgb.b);
    },

    hsb2hex: function(H, S, B) {
        var rgb = this.hsb2rgb(H, S, B);
        return this.rgb2hex(rgb.r, rgb.g, rgb.b);
    },

    hsb2hexString: function(H, S, B, prefix) {
        var rgb = this.hsb2rgb(H, S, B);
        return this.rgb2hexString(rgb.r, rgb.g, rgb.b, prefix);
    },

    hsl2hexString: function(H, S, L, prefix) {
        var rgb = this.hsl2rgb(H, S, L);
        return this.rgb2hexString(rgb.r, rgb.g, rgb.b, prefix);
    },

    rgb2hexString: function(R, G, B, prefix) {
        return (prefix == undefined ? '#' : prefix) +
            (R < 16 ? '0' : '') + R.toString(16) +
            (G < 16 ? '0' : '') + G.toString(16) +
            (B < 16 ? '0' : '') + B.toString(16);
    },

    hex2String: function(hex) {
        var rgb = this.hex2rgb(hex);
        return this.rgb2hexString(rgb.r, rgb,g, rgb,b);
    },

    hex2rgb: function(hex) {
        return {
            r: (0xff0000 & hex) >> 16,
            g: (0x00ff00 & hex) >> 8,
            b: (0x0000ff & hex)
        };
    },

    hex2hsl: function(hex) {
        var rgb = this.hex2rgb(hex);
        return this.rgb2hsl(rgb.r, rgb.g, rgb.b);
    },

    hex2hsb: function(hex) {
        var rgb = this.hex2rgb(hex);
        return this.rgb2hsb(rgb.r, rgb.g, rgb.b);
    },

    rgb2hex: function(R, G, B) {
        return ((R << 16) + (G << 8) + B);
    },

    rgb2hsl: function(R, G, B) {
        var min, max, i, l, s, maxcolor, h, rgb = [];
        rgb[0] = R / 255;
        rgb[1] = G / 255;
        rgb[2] = B / 255;
        min = rgb[0];
        max = rgb[0];
        maxcolor = 0;
        for (i = 0; i < rgb.length - 1; i++) {
            if (rgb[i + 1] <= min) {min = rgb[i + 1];}
            if (rgb[i + 1] >= max) {max = rgb[i + 1];maxcolor = i + 1;}
        }
        if (maxcolor == 0) {
            h = (rgb[1] - rgb[2]) / (max - min);
        }
        if (maxcolor == 1) {
            h = 2 + (rgb[2] - rgb[0]) / (max - min);
        }
        if (maxcolor == 2) {
            h = 4 + (rgb[0] - rgb[1]) / (max - min);
        }
        if (isNaN(h)) {h = 0;}
        h = h * 60;
        if (h < 0) {h = h + 360; }
        l = (min + max) / 2;
        if (min == max) {
            s = 0;
        } else {
            if (l < 0.5) {
                s = (max - min) / (max + min);
            } else {
                s = (max - min) / (2 - max - min);
            }
        }
        return {
            h : h,
            s : Math.round(s * 100),
            l : Math.round(l * 100)
        };
    },

    hsb2rgb: function(H, S, B) {
        var hsl = this.hsb2hsl(H, S, B);
        return this.hsl2rgb(hsl.h, hsl.s, hsl.l);
    },

    hsl2hsb: function(H, S, L) {
        S /= 100;
        L /= 100;
        var b = ((2 * L) + S * (1 - Math.abs(2 * L - 1))) * 0.5;
        return {
            h: H,
            s: Math.round(((2 * (b - L)) / b) * 100),
            b: Math.round(b * 100)
        }
    },

    hsb2hsl: function(H, S, B) {
        S /= 100;
        B /= 100;
        var L = 0.5 * B * (2 - S);
        return {
            h: H,
            s: Math.round(((B * S) / (1 - Math.abs(2 * L - 1))) * 100),
            l: Math.round(L * 100)
        }
    },

    hue2rgb: function(t1, t2, H) {
        if (H < 0) H += 6;
        if (H >= 6) H -= 6;
        if (H < 1) return (t2 - t1) * H + t1;
        else if (H < 3) return t2;
        else if (H < 4) return (t2 - t1) * (4 - H) + t1;
        else return t1;
    }
};

// logging shortcut
function log(str) {
    console.log(str);
}

// converts from degrees to radians.
Math.radians = function(degrees) {
    return degrees * Math.PI / 180;
};

// converts from radians to degrees.
Math.degrees = function(radians) {
    return radians * 180 / Math.PI;
};

// returns whether a number is odd
Math.isOdd = function(n) {
    return Math.abs(n % 2) == 1;
};

// returns whether a number is even
Math.isEven = function(n) {
    return n % 2 == 0;
};

// linear congruential generator object (default seed = unix_timestamp)
Math.LCG = function(seed) {
    // use the C99 / C11 default values
    // https://en.wikipedia.org/wiki/Linear_congruential_generator
    var m = 0x80000000; // 25
    var a = 1103515245; // 11
    var c = 12345;      // 17
    var x = (typeof(seed) == 'number' ? seed : (new Date()).getTime());

    // sow a new seed
    this.sow = function(seed) {
        var x = (typeof(seed) == 'number' ? seed : x);
    };

    // get current seed
    this.getSeed = function() {
        return x;
    };

    // return 1, -1
    this.sign = function(seed) {
        x = (typeof(seed) == 'number' ? seed : x);
        x = (a * x + c) % m;
        return (x/m > 0.5 ? 1 : -1);
    };

    // return true, false depending on probability p
    this.prob = function(p, seed) {
        return (this.float(seed) <= p && p);
    };

    // return true, false
    this.boolean = function(seed) {
        return (this.float(seed) >= 0.5);
    };

    // return integer between min and max
    this.integerInRange = function(min, max, seed) {
        x = (typeof(seed) == 'number' ? seed : x);
        x = (a * x + c) % m;
        return Math.min(min, max) + Math.round(x/m * Math.abs(max - min));
    };

    // alias for integerInRange()
    this.between = function(min, max, seed) {
        return this.integerInRange(min, max, seed);
    };

    // return float between 0, 1
    this.float = function(seed) {
        x = (typeof(seed) == 'number' ? seed : x);
        x = (a * x + c) % m;
        return x/m;
    };

    // alias for float()
    this.get = function(seed) {
        return this.float(seed);
    };
};

Perlin = {

    game: null,

    /**
     * initialise the Perlin Noise factory
     *
     * @param game
     */
    init: function(game) {
        this.game = game;
    },

    /**
     * combine the array of bitmapDatas
     *
     * @param bmdArray  - array of bitmaps
     * @param mArray    - array of weightings (sum <= 1) (default 1 / sum[bmdArray])
     */
    combineBitmapArray: function(bmdArray, mArray) {

        if (this.game === null) {
            log('ERROR: Perlin object not initialised.');
            return;
        }

        if (!Array.isArray(bmdArray)) {
            log('ERROR: first param is not array.');
            return;
        }

        var len = bmdArray.length;

        if (mArray === undefined) {
            mArray = [];
            for (var i = 0 ; i < len ; i++) {
                mArray.push(1 / len);
            }
        } else {
            if (mArray.length != bmdArray.length) {
                log('ERROR: param array lengths differ.')
                return;
            }
        }

        var w = bmdArray[0].width;
        var h = bmdArray[0].height;

        for (i = 1 ; i < len ; i++) {
            if (bmdArray[i].width != w || bmdArray[i].height != h) {
                log('ERROR: bitmap sizes differ.')
                return;
            }
        }

        var bmd = this.game.make.bitmapData(w, h);

        var rect = new Phaser.Rectangle(0, 0, w, h);

        var pxl = [];
        for (i = 0 ; i < len ; i++) {
            pxl.push(bmdArray[i].getPixels(rect));
        }

        for (var x = 0 ; x < w ; x++) {
            for (var y = 0 ; y < h ; y++) {

                // get the 4th 8-bit number (the alpha channel) in linear array of pixels
                var n = (x + y * w) * 4 + 3;

                var a = 0;

                for (i = 0 ; i < len ; i++) {
                    a += pxl[i].data[n] * mArray[i];
                }

                a = Math.max(0, Math.min(255, Math.round(a)));

                bmd.setPixel32(x, y, 255, 255, 255, a, false);
            }
        }

        bmd.context.putImageData(bmd.imageData, 0, 0);
        bmd.dirty = true;

        return bmd;
    },

    /**
     * combine array of 2D pixel arrays and return single array
     *
     * @param pxlArray  - array of 2D pixel arrays
     * @param mArray    - array of weightings (sum <= 1) (default 1 / sum[pxlArray])
     * @returns {Array}
     */
    combinePixelDataArray: function(pxlArray, mArray) {

        if (this.game === null) {
            log('ERROR: Perlin object not initialised.');
            return;
        }

        if (!Array.isArray(pxlArray)) {
            log('ERROR: first param not array.');
            return;
        }

        var len = pxlArray.length;

        if (mArray === undefined) {
            mArray = [];
            for (var i = 0 ; i < len ; i++) {
                mArray.push(1 / len);
            }
        } else {
            if (mArray.length != pxlArray.length) {
                log('ERROR: param array lengths differ.');
                return;
            }
        }

        var w = pxlArray[0].length;
        var h = pxlArray[0][0].length;

        for (i = 1 ; i < len ; i++) {
            if (pxlArray[i].length != w || pxlArray[i][0].length != h) {
                log('ERROR: pixel array sizes differ.');
                return;
            }
        }

        var pxl = [];
        for (var x = 0 ; x < w ; x++) {
            pxl.push([]);
            for (var y = 0 ; y < h ; y++) {
                var a = 0;
                for (i = 0 ; i < len ; i++) {
                    a += pxlArray[i][x][y] * mArray[i];
                }
                pxl[x][y] = Math.min(255, Math.max(0, Math.round(a)));
            }
        }

        return pxl;
    },

    /**
     * combines two bitmaps to generate a third new bitmap
     *
     * @param bmd1  - first bitmap
     * @param bmd2  - second bitmap
     * @param m     - weighting factor (bmd1.a * m + bmd2.a * (1-m)) = new.a (default 0.5)
     * @returns new bitmapData object
     */
    combineBitmaps: function(bmd1, bmd2, m) {

        if (this.game === null) {
            log('ERROR: Perlin object not initialised.');
            return;
        }

        if (bmd1.width != bmd2.width && bmd1.height != bmd2.height) {
            log('ERROR: bitmap sizes differ.');
            return;
        }

        if (m === undefined) { m = 0.5; }

        var w = bmd1.width;
        var h = bmd1.height;

        var bmd = this.game.make.bitmapData(w, h);

        var rect = new Phaser.Rectangle(0, 0, w, h);

        var pxl1 = bmd1.getPixels(rect);
        var pxl2 = bmd2.getPixels(rect);

        for (var x = 0 ; x < w ; x++) {
            for (var y = 0 ; y < h ; y++) {
                // get the 4th 8-bit number (the alpha channel) in linear array of pixels
                var n = (x + y * w) * 4 + 3;
                var a1 = pxl1.data[n];
                var a2 = pxl2.data[n];
                var a = Math.max(0, Math.min(255, Math.round(a1 * m + a2 * (1 - m))));
                bmd.setPixel32(x, y, 255, 255, 255, a, false);
            }
        }

        bmd.context.putImageData(bmd.imageData, 0, 0);
        bmd.dirty = true;

        return bmd;
    },

    /**
     * generates a bitmapData object contain perlin noise
     *
     * @param w
     * @param h
     * @param octave
     * @param minAlpha  - default 0
     * @param maxAlpha  - default 255
     * @param seed      - default 1
     * @returns new bitmapData object
     */
    generateBitmap: function(w, h, octave, minAlpha, maxAlpha, seed) {

        if (this.game === null) {
            log('ERROR: Perlin object not initialised.');
            return;
        }

        // make sure w & h are divisible by octave
        if (w/octave != Math.round(w/octave) || h/octave != Math.round(h/octave)) {
            log('ERROR: bitmap[' + w + ',' + h + '] not divisible by octave ' + octave + '.');
            return;
        }

        if (seed === undefined) { seed = 1; }
        if (minAlpha === undefined) { minAlpha = 0; }
        if (maxAlpha === undefined) { maxAlpha = 255; }

        var lcg = new Math.LCG(seed);

        var pxl = this.generatePixelData(w, h, octave, minAlpha, maxAlpha, seed);

        var bmd = this.game.make.bitmapData(w, h);
        bmd.fill(0, 0, 0, 1);  // black and opaque

        // iterate across whole bitmap
        for (var x = 0 ; x < w ; x++) {
            for (var y = 0 ; y < h ; y++) {
                // set to false as we don't want to update the bmd yet
                bmd.setPixel32(x, y, 255, 255, 255, pxl[x][y], false);
            }
        }

        // now update the bmd
        bmd.context.putImageData(bmd.imageData, 0, 0);
        bmd.dirty = true;

        return bmd;
    },

    /**
     * generates a smoothed (linear interpolation) bitmapData object contain perlin noise
     *
     * @param w
     * @param h
     * @param octave
     * @param minAlpha  - default 0
     * @param maxAlpha  - default 255
     * @param seed      - default 1
     * @returns new bitmapData object
     */
    generateBitmapSmooth: function(w, h, octave, minAlpha, maxAlpha, seed) {

        if (this.game === null) {
            log('ERROR: Perlin object not initialised.');
            return;
        }

        // make sure w & h are divisible by octave
        if (w/octave != Math.round(w/octave) || h/octave != Math.round(h/octave)) {
            log('ERROR: bitmap[' + w + ',' + h + '] not divisible by octave ' + octave + '.');
            return;
        }

        var bmd = this.game.make.bitmapData(w, h);
        bmd.fill(0, 0, 0, 1);  // black and opaque

        if (seed === undefined) { seed = 1; }
        if (minAlpha === undefined) { minAlpha = 0; }
        if (maxAlpha === undefined) { maxAlpha = 255; }

        var lcg = new Math.LCG(seed);

        var pxl = this.generatePixelDataSmooth(w, h, octave, minAlpha, maxAlpha, seed);

        // finally populate our bitmapData
        for (var x = 0 ; x < w ; x++) {
            for (var y = 0 ; y < h ; y++) {
                bmd.setPixel32(x, y, 255, 255, 255, pxl[x][y], false);
            }
        }

        // now update the bmd
        bmd.context.putImageData(bmd.imageData, 0, 0);
        bmd.dirty = true;

        return bmd;
    },

    /**
     * generate a bitmapData object containing multiple layers of perlin noise
     *
     * @param w         - width of bitmap to generate
     * @param h         - height of bitmap to generate
     * @param layers    - layers array describing each noise octave to layer onto bitmap
     * @param seed      - LCG seed
     * @returns {*}     - returns bitmapData object
     */
    generateMultiLayerBitmap: function(w, h, layers, seed) {

        if (this.game === null) {
            log('ERROR: Perlin object not initialised.');
            return;
        }

        if (seed === undefined) { seed = 1; }

        if (!Array.isArray(layers)) {
            log('ERROR: third param not array.');
            return;
        }

        var len = layers.length;

        for (var i = 0 ; i < len ; i++) {

            if (layers[i].octave === undefined) {
                log('ERROR: layer[' + i + '].octave not set.');
                return;
            }

            if (w/layers[i].octave != Math.round(w/layers[i].octave) || h/layers[i].octave != Math.round(h/layers[i].octave)) {
                log('ERROR: requested bitmap dimensions[' + w + ',' + h + '] not divisible by octave ' + layers[i].octave + '.');
                return;
            }

            if (layers[i].minAlpha === undefined) { layers[i].minAlpha = 0; }
            if (layers[i].maxAlpha === undefined) { layers[i].maxAlpha = 255; }
            if (layers[i].weight === undefined) { layers[i].weight = 1 / len; }
            if (layers[i].smooth === undefined) { layers[i].smooth = false; }
        }

        var pxlArray = [];
        for (i = 0 ; i < len ; i++) {
            pxlArray.push(
                (layers[i].smooth ?
                        this.generatePixelDataSmooth(w, h, layers[i].octave, layers[i].minAlpha, layers[i].maxAlpha, seed) :
                        this.generatePixelData(w, h, layers[i].octave, layers[i].minAlpha, layers[i].maxAlpha, seed)
                )
            );
        }

        var mArray = [];
        for (i = 0 ; i < len ; i++) {
            mArray.push(
                layers[i].weight
            )
        }

        var pxl = this.combinePixelDataArray(pxlArray, mArray);

        var bmd = this.game.make.bitmapData(w, h);
        bmd.fill(0, 0, 0, 1);  // black and opaque

        // iterate across whole bitmap
        for (var x = 0 ; x < w ; x++) {
            for (var y = 0 ; y < h ; y++) {
                // set to false as we don't want to update the bmd yet
                bmd.setPixel32(x, y, 255, 255, 255, pxl[x][y], false);
            }
        }

        // now update the bmd
        bmd.context.putImageData(bmd.imageData, 0, 0);
        bmd.dirty = true;

        return bmd;
    },

    /**
     * generate a 2D pixel array containing multiple layers of perlin noise
     *
     * @param w         - width of 2D pixel array to generate
     * @param h         - height of 2D pixel array to generate
     * @param layers    - layers array describing each noise octave to layer onto bitmap
     * @param seed      - LCG seed
     * @returns {Array} - 2D pixel array to return
     */
    generateMultiLayerPixelData: function(w, h, layers, seed) {

        if (this.game === null) {
            log('ERROR: Perlin object not initialised.');
            return;
        }

        if (seed === undefined) { seed = 1; }

        if (!Array.isArray(layers)) { return; }

        var len = layers.length;

        for (var i = 0 ; i < len ; i++) {

            if (layers[i].octave === undefined) { return; }
            if (w/layers[i].octave != Math.round(w/layers[i].octave) || h/layers[i].octave != Math.round(h/layers[i].octave)) {
                log('ERROR: requested pixel array dimensions[' + w + ',' + h + '] not divisible by octave ' + layers[i].octave + '.');
                return;
            }

            if (layers[i].minAlpha === undefined) { layers[i].minAlpha = 0; }
            if (layers[i].maxAlpha === undefined) { layers[i].maxAlpha = 255; }
            if (layers[i].weight === undefined) { layers[i].weight = 1 / len; }
            if (layers[i].smooth === undefined) { layers[i].smooth = false; }
        }

        var pxlArray = [];
        for (i = 0 ; i < len ; i++) {
            pxlArray.push(
                (layers[i].smooth ?
                        this.generatePixelDataSmooth(w, h, layers[i].octave, layers[i].minAlpha, layers[i].maxAlpha, seed) :
                        this.generatePixelData(w, h, layers[i].octave, layers[i].minAlpha, layers[i].maxAlpha, seed)
                )
            );
        }

        var mArray = [];
        for (i = 0 ; i < len ; i++) {
            mArray.push(
                layers[i].weight
            )
        }

        return this.combinePixelDataArray(pxlArray, mArray);
    },

    /**
     * generates smoothed (linear interpolation) 2D pixel alpha data array object contain perlin noise
     *
     * @param w
     * @param h
     * @param octave
     * @param minAlpha  - default 0
     * @param maxAlpha  - default 255
     * @param seed      - default 1
     * @returns 2D pixel alpha data array
     */
    generatePixelDataSmooth: function(w, h, octave, minAlpha, maxAlpha, seed) {

        if (this.game === null) {
            log('ERROR: Perlin object not initialised.');
            return;
        }

        // make sure w & h are divisible by octave
        if (w/octave != Math.round(w/octave) || h/octave != Math.round(h/octave)) {
            log('ERROR: pixel array[' + w + ',' + h + '] not divisible by octave ' + octave + '.');
            return;
        }

        if (seed === undefined) { seed = 1; }
        if (minAlpha === undefined) { minAlpha = 0; }
        if (maxAlpha === undefined) { maxAlpha = 255; }

        var lcg = new Math.LCG(seed);

        // create our pixel data container
        var pxl = [];
        for (var x = 0 ; x < w ; x++) {
            pxl.push([]);
            for (var y = 0 ; y < h ; y++) {
                pxl[x][y] = 0;
            }
        }

        // iterate across octaves and populate main alpha values
        for (x = 0 ; x < w ; x += octave) {
            for (y = 0 ; y < h ; y += octave) {
                pxl[x][y] = lcg.integerInRange(minAlpha, maxAlpha);
            }
        }

        // interpolate between octaves
        for (x = 0 ; x < w ; x += octave) {
            for (y = 0 ; y < h  ; y += octave) {

                var ax0y0 = pxl[x][y];
                var ax1y0, ax0y1, ax1y1;
                if (x + octave >= w) {
                    ax1y0 = pxl[0][y];
                    if (y + octave >= h) {
                        ax0y1 = pxl[x][0];
                        ax1y1 = pxl[0][0];
                    } else {
                        ax0y1 = pxl[x][y + octave];
                        ax1y1 = pxl[0][y + octave];
                    }
                } else {
                    ax1y0 = pxl[x + octave][y];
                    if (y + octave >= h) {
                        ax0y1 = pxl[x][0];
                        ax1y1 = pxl[x + octave][0];
                    } else {
                        ax0y1 = pxl[x][y + octave];
                        ax1y1 = pxl[x + octave][y + octave];
                    }
                }

                // iterate across section
                for (var x0 = x ; x0 < x + octave ; x0++) {
                    for (var y0 = y ; y0 < y + octave ; y0++) {

                        if (x0 == x && y0 == y) { continue; }

                        var wx = (x0 - x) / octave;
                        var wy = (y0 - y) / octave;

                        var axy0 = this.linearInterpolate(ax0y0, ax1y0, wx);
                        var axy1 = this.linearInterpolate(ax0y1, ax1y1, wx);

                        pxl[x0][y0] = this.linearInterpolate(axy0, axy1, wy);
                    }
                }
            }
        }

        return pxl;
    },

    /**
     * generates 2D pixel alpha data array object contain perlin noise
     *
     * @param w
     * @param h
     * @param octave
     * @param minAlpha  - default 0
     * @param maxAlpha  - default 255
     * @param seed      - default 1
     * @returns 2D pixel alpha data array
     */
    generatePixelData: function(w, h, octave, minAlpha, maxAlpha, seed) {

        if (this.game === null) {
            log('ERROR: Perlin object not initialised.');
            return;
        }

        // make sure w & h are divisible by octave
        if (w/octave != Math.round(w/octave) || h/octave != Math.round(h/octave)) {
            log('ERROR: pixel array[' + w + ',' + h + '] not divisible by octave ' + octave + '.');
            return;
        }

        if (seed === undefined) { seed = 1; }
        if (minAlpha === undefined) { minAlpha = 0; }
        if (maxAlpha === undefined) { maxAlpha = 255; }

        var lcg = new Math.LCG(seed);

        // generate pixel alpha data container
        var pxl = [];
        for (var x = 0 ; x < w ; x++) {
            pxl.push([]);
            for (var y = 0 ; y < h ; y++) {
                pxl[x][y] = 0;
            }
        }

        // iterate across whole bitmap
        for (x = 0 ; x < w ; x += octave) {
            for (y = 0 ; y < h ; y += octave) {

                // calculate alpha for octave section
                var a = lcg.integerInRange(minAlpha, maxAlpha);

                // iterate across section
                for (var x0 = x ; x0 < x + octave ; x0++) {
                    for (var y0 = y ; y0 < y + octave ; y0++) {
                        pxl[x0][y0] = a;
                    }
                }
            }
        }

        return pxl;
    },

    /**
     *
     * @param x0    - value between 0-255
     * @param x1    - value between 0-255
     * @param w     - weight between (0-1)
     * @returns {number}    - x0*(1-w) + x1*w
     */
    linearInterpolate: function(x0, x1, w) {

        return Math.round((x0 * (1-w)) + (x1 * w));
    }
};

// game state manager object type
function GameState() {

    this.state = null;

    this.states = [];

    this.add = function(s, isFirst) {
        this.states.push(s);
        if (isFirst === true) {
            this.set(s);
        }
    };

    this.get = function() {
        return this.state;
    };

    this.set = function(s) {
        if (this.states.indexOf(s) != -1) {
            this.state = s;
            log("state: " + this.state);
        }
    };
}

// debug function to be called in update or render function
function debugScale(g) {

    // world size

    var x = 32;
    var y = 0;
    var yi = 32;

    g.game.debug.text('game.width: ' + g.game.width, x, y += yi);
    g.game.debug.text('game.height: ' + g.game.height, x, y += yi);

    g.game.debug.text('view.width: ' + g.game.scale.width, x, y += yi);
    g.game.debug.text('view.height: ' + g.game.scale.height, x, y += yi);
}

// debug function to be called in update or render function
function debugWindow(g) {

    // debug code to demonstrate screen dimensions

    var x = 32;
    var y = 0;
    var yi = 32;

    g.game.debug.text('Viewport', x, y += yi);

    g.game.debug.text('Viewport Width: ' + g.game.scale.viewportWidth, x, y += yi);
    g.game.debug.text('window.innerWidth: ' + window.innerWidth, x, y += yi);
    g.game.debug.text('window.outerWidth: ' + window.outerWidth, x, y += yi);

    g.game.debug.text('Viewport Height: ' + g.game.scale.viewportHeight, x, y += yi);
    g.game.debug.text('window.innerHeight: ' + window.innerHeight, x, y += yi);
    g.game.debug.text('window.outerHeight: ' + window.outerHeight, x, y += yi);

    g.game.debug.text('Document', x, y += yi*2);

    g.game.debug.text('Document Width: ' + g.game.scale.documentWidth, x, y += yi);
    g.game.debug.text('Document Height: ' + g.game.scale.documentHeight, x, y += yi);

    //  Device: How to get device size.

    //  Use window.screen.width for device width and window.screen.height for device height.
    //  .availWidth and .availHeight give you the device size minus UI taskbars. (Try on an iPhone.)
    //  Device size is static and does not change when the page is resized or rotated.

    x = 350;
    y = 0;

    g.game.debug.text('Device', x, y += yi);

    g.game.debug.text('window.screen.width: ' + window.screen.width, x, y += yi);
    g.game.debug.text('window.screen.availWidth: ' + window.screen.availWidth, x, y += yi);
    g.game.debug.text('window.screen.height: ' + window.screen.height, x, y += yi);
    g.game.debug.text('window.screen.availHeight: ' + window.screen.availHeight, x, y += yi);
}

// debug function to be called in update or render function
function debugDevice(g) {

    // world size

    var x = 32;
    var y = 0;
    var yi = 32;

    // this is the actual resolution of the viewport
    g.game.debug.text('game.width: ' + g.game.width, x, y += yi);
    g.game.debug.text('game.height: ' + g.game.height, x, y += yi);

    // this is the actual pixel dimenions of the canvas that the viewport is projected onto
//    g.game.debug.text('game.width: ' + g.scale.width, x, y += yi);
//    g.game.debug.text('game.height: ' + g.scale.height, x, y += yi);

    // this is the actual resolution of the game world
//    g.game.debug.text('world.width: ' + g.world.width, x, y += yi);
//    g.game.debug.text('world.height: ' + g.world.height, x, y += yi);

    g.game.debug.text('window.screen.availWidth: ' + window.screen.availWidth, x, y += yi);
    g.game.debug.text('window.screen.availHeight: ' + window.screen.availHeight, x, y += yi);

    g.game.debug.text('Navigator: ' + navigator.userAgent, x, y += yi * 2);
    g.game.debug.text('iOS: ' + g.game.device.iOS, x, y += yi);
    g.game.debug.text('Mobile Safari: ' + g.game.device.mobileSafari, x, y += yi);
    g.game.debug.text('WebApp: ' + g.game.device.webApp, x, y += yi);
    g.game.debug.text('nav: ' + navigator['standalone'], x, y += yi);
    g.game.debug.text('app: ' + g.game.device.iOSVersion, x, y += yi);
    g.game.debug.text('device: ' + (g.game.device.desktop ? 'desktop' : 'mobile'), x, y += yi);
    g.game.debug.text('touchscreen: ' + g.game.device.touch, x, y += yi);
}

// debug function to be called in update or render function
function debugScreenCentre(g) {

    // debug code to demonstrate centre of screen

    game.debug.text('X', g.world.centerX - 4, g.world.centerY - 4)
}

// debug function to be called in update or render function
function debugOrientation(g) {

    // device orientation warning

    if (!g.game.device.desktop && window.innerHeight > window.innerWidth) {
        g.game.debug.text('Please rotate screen to landscape', 32, 32);
        return;
    }
}

// debug function to be called in update or render function
function debugFPS(g) {

    var x = 32;
    var y = 0;
    var yi = 32;

    // this is the actual resolution of the viewport
    g.game.debug.text('game.fps: ' + g.game.time.fps, x, y += yi);
    g.game.debug.text('game.time.elapsed: ' + g.game.time.elapsed + ' ms', x, y += yi);

}